<?php

namespace Kufer\Web\KuferTools\Dozent\HonorarBfi\Honorardruck;

use Kufer\Web\KuferTools\Dozent\HonorarBfi\HonorarUebersicht\HonorarUebersichtController;
use Kufer\Web\KuferTools\Utils\StatusMessages\PlainStatusMessage;
use Kufer\Web\KuferTools\Utils\StatusMessages\StatusMessage;
use Kufer\Web\KuferTools\Utils\StatusMessages\StatusMessageContainer;

class HonorardruckController extends \Kufer\Web\KuferTools\Basis\Controller\AjaxToolController
{
  protected function getRequestObj()
  {
    $requestObj = new HonorardruckRequest();
    $requestObj->zahlnummer = \GetOperations::getVarValue('zahlnummer');
    $requestObj->monatAb = \GetOperations::getVarValue('monat_ab');

    return $requestObj;
  }

  protected function getUseCase(): \Kufer\Web\KuferTools\Basis\UseCase\UseCase
  {
    return new HonorardruckUseCase(
      $this->getRequestObj()
    );
  }

  public function getPresenter($pUseCaseResponse)
  {
    return new HonorardruckPresenter($pUseCaseResponse);
  }

  protected function getControllerToForward($pUseCaseResponse)
  {
    if (empty($pUseCaseResponse->honorarDokument)) {
      $messageContainer = StatusMessageContainer::getSharedInstance();
      $messageContainer->addStatusMessageObj(new PlainStatusMessage(StatusMessage::MSG_BOX_ERROR, 'Der PDF-Ausdruck der Honorarabrechnung wurde nicht gefunden'));
      return new HonorarUebersichtController();
    } else {
      return null;
    }
  }
}